searchNodes=[{"doc":"Formats Surface ~H sigils and .sface files in the given files and patterns.mix surface.format &quot;lib/**/*.{ex,exs}&quot; &quot;test/**/*.{ex,exs}&quot;Takes the same options as mix format except for --check-equivalent.Formatting optionsLike mix format, the Surface formatter reads a .formatter.exs file in the current directory for formatter configuration. The Surface formatter accepts the same options as mix format. Read more about the expected format of .formatter.exs and the shared configuration options documented here.The Surface formatter also takes the following two additional options specified in .formatter.exs::surface_line_length overrides :line_length only for mix surface.format (:line_length is used otherwise, or defaults to 98):surface_inputs overrides :inputs only for mix surface.format (:inputs is used otherwise)Task-specific optionsThe Surface formatter accepts the same task-specific options as mix format. Read documentation for the options documented here..For quick reference, here are some examples of using these options:$ mix surface.format --check-formatted ** (Mix) mix surface.format failed due to --check-formatted. The following files are not formatted: * path/to/component.ex * path/to/file.sface$ mix surface.format --dry-run$ mix surface.format --dot-formatter path/to/.formatter.exsYou can also use the same syntax as mix format for specifying which files to format:$ mix surface.format path/to/file.ex &quot;lib/**/*.{ex,exs}&quot; &quot;test/**/*.{ex,exs}&quot;","ref":"Mix.Tasks.Surface.Format.html","title":"Mix.Tasks.Surface.Format","type":"task"},{"doc":"Utilities for dealing with Surface code","ref":"Surface.Code.html","title":"Surface.Code","type":"module"},{"doc":"Formats the given Surface code string. (Typically the contents of an ~H sigil or .sface file.)In short:HTML/Surface elements are indented to the right of their parents.Attributes are split on multiple lines if the line is too long; otherwise on the same line.Elixir code snippets (inside {{ }}) are ran through the Elixir code formatter.Lack of whitespace is preserved, so that intended behaviors are not removed. (For example, &lt;span&gt;Foo bar baz&lt;/span&gt; will not have newlines or spaces added.)Below the Options section is a non-exhaustive list of behaviors of the formatter.Options:line_length - the line length to aim for when formatting the document. Defaults to 98. As with the Elixir formatter, this value is used as reference but is not always enforced depending on the context.IndentationThe formatter ensures that children are indented one tab (two spaces) in from their parent.WhitespaceWhitespace that existsAs in regular HTML, any string of continuous whitespace is considered equivalent to any other string of continuous whitespace. There are three exceptions:Macro components (with names starting with #, such as &lt;#Markdown&gt;)&lt;pre&gt; tags&lt;code&gt; tagsThe contents of those tags are considered whitespace-sensitive, and developers should sanity check after running the formatter.Whitespace that doesn't exist (Lack of whitespace)As is sometimes the case in HTML, lack of whitespace is considered significant. Instead of attempting to determine which contexts matter, the formatter consistently retains lack of whitespace. This means that the following&lt;div&gt;&lt;p&gt;Hello&lt;/p&gt;&lt;/div&gt;will not be changed. However, the following&lt;div&gt; &lt;p&gt; Hello &lt;/p&gt; &lt;/div&gt;will be formatted as&lt;div&gt; &lt;p&gt; Hello &lt;/p&gt; &lt;/div&gt;because of the whitespace on either side of each tag.To be clear, this example&lt;div&gt; &lt;p&gt;Hello&lt;/p&gt; &lt;/div&gt;will be formatted as&lt;div&gt; &lt;p&gt;Hello&lt;/p&gt; &lt;/div&gt;because of the lack of whitespace in between the opening and closing &lt;p&gt; tags and their child content.Splitting children onto separate linesIf there is a not a lack of whitespace that needs to be respected, the formatter puts separate nodes (e.g. HTML elements, interpolations {{ ... }}, etc) on their own line. This means that&lt;div&gt; &lt;p&gt;Hello&lt;/p&gt; {{1 + 1}} &lt;p&gt;Goodbye&lt;/p&gt; &lt;/div&gt;will be formatted as&lt;div&gt; &lt;p&gt;Hello&lt;/p&gt; {{ 1 + 1 }} &lt;p&gt;Goodbye&lt;/p&gt; &lt;/div&gt;Newline charactersThe formatter will not add extra newlines unprompted beyond moving nodes onto their own line. However, if the input code has extra newlines, the formatter will retain them but will collapse more than one extra newline into a single one.This means that&lt;section&gt; Hello &lt;/section&gt;will be formatted as&lt;section&gt; Hello &lt;/section&gt;It also means that&lt;section&gt; &lt;p&gt;Hello&lt;/p&gt; &lt;p&gt;and&lt;/p&gt; &lt;p&gt;Goodbye&lt;/p&gt; &lt;/section&gt;will be formatted as&lt;section&gt; &lt;p&gt;Hello&lt;/p&gt; &lt;p&gt;and&lt;/p&gt; &lt;p&gt;Goodbye&lt;/p&gt; &lt;/section&gt;AttributesHTML attributes such as class in &lt;p class=&quot;container&quot;&gt; are formatted to make use of Surface features.Inline literalsString, integer, and boolean literals are placed after the = without any interpolation brackets ({{ }}). This means that&lt;Component foo={{ &quot;hello&quot; }} bar={{123}} secure={{ false }} /&gt;will be formatted as&lt;Component foo=&quot;hello&quot; bar=123 secure=false /&gt;One exception is that true boolean literals are formatted using the Surface shorthand whereby you can simply write the name of the attribute and it is passed in as true. For example,&lt;Component secure={{ true }} /&gt;and&lt;Component secure=true /&gt;will both be formatted as&lt;Component secure /&gt;Interpolation ({{ }} brackets)Attributes that interpolate Elixir code with {{ }} brackets are ran through the Elixir code formatter.This means that:&lt;Foo num=123456 /&gt; becomes &lt;Foo num=123_456 /&gt;list={{[1,2,3]}} becomes list={{ [1, 2, 3] }}things={{ %{one: &quot;1&quot;, two: &quot;2&quot;}}} becomes things={{ %{ one: &quot;1&quot;, two: &quot;2&quot; } }}Sometimes the Elixir code formatter will add line breaks in the formatted expression. In that case, SurfaceFormatter will ensure indentation lines up. If there is a single attribute, it will keep the attribute on the same line as the tag name, for example:&lt;Component list={{[ {&quot;foo&quot;, foo}, {&quot;bar&quot;, bar} ]}} /&gt;However, if there are multiple attributes it will put them on separate lines:&lt;Child list={{[ {&quot;foo&quot;, foo}, {&quot;bar&quot;, bar} ]}} int=123 /&gt;Note in the above example that if the Elixir code formatter introduces newlines, whitespace between the expression and the interpolation brackets is collapsed. That is to say the formatter will emit list={{[ instead of list={{ [.Wrapping attributes on separate linesIn the Interpolation ({{ }} brackets) section we noted that attributes will each be put on their own line if there is more than one attribute and at least one contains a newline after being formatted by the Elixir code formatter.There is another scenario where attributes will each be given their own line: any time the opening tag would exceed line_length if put on one line. This value is provided in .formatter.exs and defaults to 98.The formatter indents attributes one tab in from the start of the opening tag for readability:&lt;div class=&quot;very long class value that causes this to exceed the established line length&quot; aria-role=&quot;button&quot; &gt;If you desire to have a separate line length for mix format and mix surface.format, provide surface_line_length in .formatter.exs and it will be given precedence when running mix surface.format. For example:# .formatter.exs [ surface_line_length: 120, import_deps: [...], # ... ]HTML CommentsThe formatter removes HTML comments. This is because the Surface parser (which SurfaceFormatter uses under the hood) does not expose them.This means&lt;div&gt; &lt;!-- Some comment --&gt; &lt;p&gt;Hello&lt;/p&gt; &lt;/div&gt;becomes&lt;div&gt; &lt;p&gt;Hello&lt;/p&gt; &lt;/div&gt;It is recommended to use an interpolated Elixir comment instead:&lt;div&gt; {{ # Some comment }} &lt;p&gt;Hello&lt;/p&gt; &lt;/div&gt;As with all changes (for both mix format and mix surface.format) it's recommended that developers don't blindly run the formatter on an entire codebase and commit, but instead sanity check each file to ensure the results are desired.","ref":"Surface.Code.html#format_string!/2","title":"Surface.Code.format_string!/2","type":"function"},{"doc":"Functions for formatting Surface code snippets.","ref":"Surface.Code.Formatter.html","title":"Surface.Code.Formatter","type":"module"},{"doc":"Given a list of formatter_node/0, return a formatted string of Surface code","ref":"Surface.Code.Formatter.html#format/2","title":"Surface.Code.Formatter.format/2","type":"function"},{"doc":"Given a string of Surface code, return a list of surface nodes including special whitespace nodes that enable formatting.","ref":"Surface.Code.Formatter.html#parse/1","title":"Surface.Code.Formatter.parse/1","type":"function"},{"doc":"Deeply traverse parsed Surface nodes, converting string nodes into a list of strings and :whitespace atoms.","ref":"Surface.Code.Formatter.html#parse_whitespace/1","title":"Surface.Code.Formatter.parse_whitespace/1","type":"function"},{"doc":"A parsed HTML/Component attribute name and value","ref":"Surface.Code.Formatter.html#t:attribute/0","title":"Surface.Code.Formatter.attribute/0","type":"type"},{"doc":"The value of a parsed HTML/Component attribute","ref":"Surface.Code.Formatter.html#t:attribute_value/0","title":"Surface.Code.Formatter.attribute_value/0","type":"type"},{"doc":"A node output by parse/1. Simply a transformation of the output of parse/1, with contextualized whitespace nodes parsed out of the string nodes.","ref":"Surface.Code.Formatter.html#t:formatter_node/0","title":"Surface.Code.Formatter.formatter_node/0","type":"type"},{"doc":":line_length - Maximum line length before wrapping opening tags:indent - Starting indentation depth depending on the context of the ~H sigil","ref":"Surface.Code.Formatter.html#t:option/0","title":"Surface.Code.Formatter.option/0","type":"type"},{"doc":"A node output by Surface.Compiler.Parser.parse/1","ref":"Surface.Code.Formatter.html#t:surface_node/0","title":"Surface.Code.Formatter.surface_node/0","type":"type"},{"doc":"The name of an HTML/Surface tag, such as div, ListItem, or #Markdown","ref":"Surface.Code.Formatter.html#t:tag/0","title":"Surface.Code.Formatter.tag/0","type":"type"},{"doc":"Context of a section of whitespace. This allows the formatter to decide things such as how much indentation to provide after a newline.","ref":"Surface.Code.Formatter.html#t:whitespace_context/0","title":"Surface.Code.Formatter.whitespace_context/0","type":"type"},{"doc":"SurfaceFormatter A code formatter for https://hex.pm/packages/surfaceThe complete documentation for SurfaceFormatter is located here.","ref":"readme.html","title":"SurfaceFormatter","type":"extras"},{"doc":"Add as a dependency in mix.exs:defp deps do [ {:surface_formatter, &quot;~&gt; 0.2.0&quot;} ] end","ref":"readme.html#installation","title":"SurfaceFormatter - Installation","type":"extras"},{"doc":"$ mix surface.formatSee mix surface.format for documentation of flags and configuration options.","ref":"readme.html#usage","title":"SurfaceFormatter - Usage","type":"extras"},{"doc":"The formatter mostly follows these rules:Only formats code inside of ~H&quot;&quot;&quot; blocks and .sface files.Child nodes are indented 2 spaces in from their parent.Interpolated Elixir code (inside {{ }} brackets) is formatted by the official Elixir formatter.HTML attributes are put on separate lines if the line is too long.Retains &quot;lack of whitespace&quot; such as &lt;p&gt;No whitespace between text and tags&lt;/p&gt;.Collapses extra newlines down to at most one blank line.See Surface.Code.format_string!/2 for further documentation.","ref":"readme.html#formatting-rules","title":"SurfaceFormatter - Formatting rules","type":"extras"},{"doc":"Out of the box, Surface code that looks like this: &lt;RootComponent with_many_attributes={{ true }} causing_this_line_to_wrap={{ true}} because_it_is_too_long={{ &quot;yes&quot; }}&gt; &lt;!-- An HTML comment --&gt; {{#An Elixir comment}} &lt;div :if={{@show_div}} class=&quot;container&quot;&gt; &lt;p&gt; Text inside paragraph &lt;/p&gt; &lt;span&gt;Text touching parent tags&lt;/span&gt; &lt;/div&gt; &lt;Child items={{[%{name: &quot;Option 1&quot;, key: 1}, %{name: &quot;Option 2&quot;, key: 2}, %{name: &quot;Option 3&quot;, key: 3}, %{name: &quot;Option 4&quot;, key: 4}]}}&gt; Contents &lt;/Child&gt; &lt;/RootComponent&gt;will be formatted like this:&lt;RootComponent with_many_attributes causing_this_line_to_wrap because_it_is_too_long=&quot;yes, this line is long enough to wrap&quot; &gt; {{ # An Elixir comment }} &lt;div :if={{ @show_div }} class=&quot;container&quot;&gt; &lt;p&gt; Text inside paragraph &lt;/p&gt; &lt;span&gt;Text touching parent tags&lt;/span&gt; &lt;/div&gt; &lt;Child items={{[ %{name: &quot;Option 1&quot;, key: 1}, %{name: &quot;Option 2&quot;, key: 2}, %{name: &quot;Option 3&quot;, key: 3}, %{name: &quot;Option 4&quot;, key: 4} ]}}&gt; Contents &lt;/Child&gt; &lt;/RootComponent&gt;","ref":"readme.html#example-at-a-glance","title":"SurfaceFormatter - Example at a glance","type":"extras"},{"doc":"If your project includes .sface files, use the :surface_inputs option (instead of :inputs) in .formatter.exs to specify patterns for files containing Surface code.Without :surface_inputs, the formatter falls back to :inputs. Including .sface files in :inputs causes mix format to crash.# Example .formatter.exs preventing `mix format` from crashing on .sface files [ surface_line_length: 120, import_deps: [:ecto, :phoenix, :surface], inputs: [&quot;*.{ex,exs}&quot;, &quot;priv/*/seeds.exs&quot;, &quot;{config,lib,test}/**/*.{ex,exs}&quot;], surface_inputs: [&quot;{lib,test}/**/*.{ex,sface}&quot;], subdirectories: [&quot;priv/*/migrations&quot;] ]","ref":"readme.html#formatting-sface-files","title":"SurfaceFormatter - Formatting .sface files","type":"extras"},{"doc":"Changelog","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Require Surface v0.2.0 (#2)","ref":"changelog.html#v0-2-0-2021-01-28","title":"Changelog - v0.2.0 (2021-01-28)","type":"extras"},{"doc":"Fix crash for self-closing &lt;pre&gt;, &lt;code&gt;, and &lt;#Macro&gt; tags. (#1)Fix crash when &lt;pre&gt;, &lt;code&gt;, and &lt;#Macro&gt; tags contained components, HTML elements, or interpolations. (#3)","ref":"changelog.html#v0-1-1-2021-01-28","title":"Changelog - v0.1.1 (2021-01-28)","type":"extras"},{"doc":"Initial release","ref":"changelog.html#v0-1-0-2021-01-25","title":"Changelog - v0.1.0 (2021-01-25)","type":"extras"}]